'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RegexInputString = function RegexInputString() {
	var input = arguments.length <= 0 || arguments[0] === undefined ? '' : arguments[0];
	var flags = arguments.length <= 1 || arguments[1] === undefined ? '' : arguments[1];

	_classCallCheck(this, RegexInputString);

	if (typeof input !== 'string') throw new Error('\'input\' must be a string');
	if (typeof flags !== 'string') throw new Error('\'flags\' must be a string');

	// parse input
	var match = /^\/(.+)\/([a-zA-Z]*)$/.exec(input),
	    // determine is using regex syntax
	pattern = match ? match[1] : input.replace(/\\/g, '\\\\').replace(/[\(\)\[\]\{\}\|\.\?\*\+\-\^\$\!\/]/g, '\\$&'); // process special characters

	// merge flags from regex syntax
	if (match && match[2]) {
		(function () {
			var flagsArray = flags.split(''),
			    matchArray = match[2].split('');

			matchArray.forEach(function (flag) {
				if (flagsArray.indexOf(flag) < 0) flagsArray.push(flag);
			});

			flags = flagsArray.join('');
		})();
	}

	return new RegExp(pattern, flags);
};

exports.default = RegexInputString;